﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;
using System.Configuration;

/*******************************************************
 
 ** 作者: SoFlash - 博客园  http://www.cnblogs.com/longwu
 
 ** 描述: FrmPwdChange.cs  密码修改窗体 用于管理员和普通用户修改个人密码

 ******************************************************/

namespace 电影记录管理系统
{
    public partial class FrmPwdChange : Form
    {
        public FrmPwdChange()
        {
            InitializeComponent();
           
        }

        //连接字符串 获取配置文件里的连接路径
        static string connStr = ConfigurationManager.ConnectionStrings["str"].ConnectionString;

        //修改密码
        private void btnOK_Click(object sender, EventArgs e)
        {
            //使用Sql连接对象获取连接字符串
            SqlConnection conn = new SqlConnection(connStr);
            //使用sql语句获取当前用户名下的密码
            string sql = "select MUserPwd from MovieAccount where MUserName ='" + txtUsername.Text + "'";
            //使用SQLcommand指令来装载SQL连接字符串和conn连接对象
            SqlCommand cmd = new SqlCommand(sql, conn);
            //打开conn连接
            conn.Open();
            //使用sql数据读取器来 获取cmd指令中的读到的数据
            SqlDataReader sdr = cmd.ExecuteReader();
            //如果sql数据读取器 读到了数据
            if (sdr.Read())
            {
                //将读到的用户名下的密码赋给字符串oldPwd
                string oldPwd = sdr.GetString(0).Trim();
                //如果文本框中输入的密码等于从数据库中读到的字符串oldPwd
                if (oldPwd == txtOldPwd.Text)
                {
                    //如果新密码为空
                    if (txtNewPwd.Text.Trim() == "" || txtNewPwdConfirm.Text.Trim() == "")
                    {
                        //弹出提示
                        MessageBox.Show("新密码不能为空!");
                        return;
                    }
                    //继续判断 如果2次新密码不相同
                    else if (txtNewPwd.Text.Trim() != txtNewPwdConfirm.Text.Trim())
                    {
                        //弹出提示 2次新密码不相同,请重新输入
                        MessageBox.Show("2次输入的新密码不一样,请重新输入!");
                        //新密码和再次证明密码提示框都清空
                        txtNewPwd.Text = "";
                        txtNewPwdConfirm.Text = "";
                        return;
                    }
                    else
                    {
                        //如果2次新密码相同,关闭SqlDataReader连接
                        sdr.Close();
                        //执行sql语句
                        string sqlUpdate = "update MovieAccount set MUserPwd ='" + txtNewPwdConfirm.Text +
                        "' where MUserName ='" + txtUsername.Text + "'";
                        //new一个数据库更新指令
                        SqlCommand cmdUp = new SqlCommand(sqlUpdate, conn);
                        // 如果cmdUp获取的行数为0 则说明系更新指令出现异常
                        if (cmdUp.ExecuteNonQuery() == 0)
                        {
                            //系统报错 
                            MessageBox.Show("未知错误!");
                            return;
                        }
                        else
                        {
                            //否则 更新成功
                            MessageBox.Show("恭喜你!密码修改成功!");
                        }

                    }
                }
                else
                {
                    //弹出提示框 旧密码不能为空或错误
                    MessageBox.Show("旧密码错误或者不能为空");
                    //旧密码,新密码,新密码验证 同时清空
                    txtOldPwd.Text = "";
                    txtNewPwd.Text = "";
                    txtNewPwdConfirm.Text = "";
                    return;
                }
            }
            else
            {
                //如果没读到用户名,提示用户名不存在!
                MessageBox.Show("用户名不存在,请重新输入!");
                //用用户名,旧密码,新密码,新密码验证 都清空  
                txtUsername.Text = "";
                txtOldPwd.Text = "";
                txtNewPwd.Text = "";
                txtNewPwdConfirm.Text = "";
                return;

            }
            //关闭数据库连接
            conn.Close();

        }

        //返回主窗体
        private void btnBack_Click(object sender, EventArgs e)
        {
            //new 一个主框体的对象
            FrmMain main = new FrmMain();
            main.Show();
            this.Close();
        }
        //获取登录窗体的用户名
        private void FrmPwdChange_Load(object sender, EventArgs e)
        {
            //获取登录窗体登录成功后的公共变量 Uid
            string currentUser = FrmLogin.Uid;
            //将获取的字符串 currentUser 赋给txtUsername文本框
            txtUsername.Text = currentUser;
        }
    }
}
